package gonganxitong

import (
	"shylinux.com/x/ice"
	"shylinux.com/x/icebergs/base/web"
	kit "shylinux.com/x/toolkits"

	"shylinux.com/x/community/src/gonganxitong/model"
	"shylinux.com/x/mysql-story/src/db"
)

type Table struct {
	db.Table
	list string `name:"list place_uid uid auto"`
}

func (s Table) Inputs(m *ice.Message, arg ...string) {
	s.Table.Inputs(m, arg...)
}
func (s Table) Init(m *ice.Message, arg ...string) {
	kit.If(m.Config(web.PORTAL) == ice.TRUE, func() { portal{}.Show(m) })
}
func (s Table) List(m *ice.Message, arg ...string) *ice.Message {
	if len(arg) == 0 || len(arg) == 1 {
		if m.IsTech() {
			s.Table.List(m)
		}
	} else if len(arg) == 2 {
		s.Table.Select(m.FieldsSetDetail(), model.UID, arg[1])
	}
	return m
}
func (s Table) RewriteAppend(m *ice.Message, arg ...string) *ice.Message {
	m.RewriteAppend(func(value, key string, index int) string {
		kit.If(key == model.PLACE_TYPE, func() { value = PlaceType(kit.Int(value)).String() })
		kit.If(key == model.USER_PLACE_ROLE, func() { value = UserPlaceRole(kit.Int(value)).String() })
		kit.If(key == model.ORDER_STATUS, func() { value = OrderStatus(kit.Int(value)).String() })
		kit.If(key == model.APPLY_STATUS, func() { value = ApplyStatus(kit.Int(value)).String() })
		return value
	})
	return m
}
func (s Table) SendTemplate(m *ice.Message, user_uid, title string) {
	if !m.IsErr() {
		m.Cmd(user{}, user{}.SendTemplate, user_uid, cmdurl(m, m.Option(model.PLACE_UID), m.PrefixKey(), m.Option(model.UID)),
			title, m.Option(model.PLACE_NAME), kit.Cut(m.Option(model.UID), 6))
	}
}
func cmdurl(m *ice.Message, arg ...string) string {
	return m.MergePodCmd("", m.Prefix(web.PORTAL), ice.MSG_DEBUG, m.Option(ice.MSG_DEBUG)) +
		"#" + kit.Join([]string{arg[0], kit.Select(m.PrefixKey(), arg, 1), kit.Select("", arg, 2)}, ":")
}

func prefixKey() string { return kit.Keys("web.team", kit.PathName(-1), kit.FileName(-1)) }
