package gonganxitong

import (
	"shylinux.com/x/ice"

	"shylinux.com/x/community/src/gonganxitong/model"
)

type place struct{ Table }

func (s place) Inputs(m *ice.Message, arg ...string) {
	switch arg[0] {
	case model.PLACE_TYPE:
		for k, v := range PlaceTypeList {
			m.Push(arg[0], k).Push(model.NAME, v)
		}
		m.SortInt(arg[0]).DisplayInputKeyNameIconTitle()
	default:
		s.Table.Inputs(m, arg...)
	}
}

func init() { ice.Cmd(prefixKey(), place{}) }

type PlaceType int

const (
	PlaceHouse PlaceType = iota
	PlaceHotel
	PlaceStore
	PlacePublic
	PlaceSchool
	PlaceOffice
	PlaceFactory
	PlaceHospital
)

var PlaceTypeList = map[PlaceType]string{
	PlaceHouse:    "house",
	PlaceHotel:    "hotel",
	PlaceStore:    "store",
	PlacePublic:   "public",
	PlaceSchool:   "school",
	PlaceOffice:   "office",
	PlaceFactory:  "factory",
	PlaceHospital: "hospital",
}

func (s PlaceType) String() string { return PlaceTypeList[s] }
